<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AuthServerOAuth2Config.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">astrapay-otp</a> &gt; <a href="index.source.html" class="el_package">com.astrapay.otp.config</a> &gt; <span class="el_source">AuthServerOAuth2Config.java</span></div><h1>AuthServerOAuth2Config.java</h1><pre class="source lang-java linenums">package com.astrapay.otp.config;

import com.astrapay.otp.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.security.oauth2.config.annotation.configurers.ClientDetailsServiceConfigurer;
import org.springframework.security.oauth2.config.annotation.web.configuration.AuthorizationServerConfigurerAdapter;
import org.springframework.security.oauth2.config.annotation.web.configuration.EnableAuthorizationServer;
import org.springframework.security.oauth2.config.annotation.web.configurers.AuthorizationServerEndpointsConfigurer;
import org.springframework.security.oauth2.config.annotation.web.configurers.AuthorizationServerSecurityConfigurer;
import org.springframework.security.oauth2.provider.client.ClientCredentialsTokenEndpointFilter;
import org.springframework.security.oauth2.provider.error.OAuth2AccessDeniedHandler;
import org.springframework.security.oauth2.provider.token.DefaultTokenServices;
import org.springframework.security.oauth2.provider.token.TokenEnhancer;
import org.springframework.security.oauth2.provider.token.TokenEnhancerChain;
import org.springframework.security.oauth2.provider.token.TokenStore;
import org.springframework.security.oauth2.provider.token.store.JdbcTokenStore;
import javax.sql.DataSource;
import java.util.Arrays;

@Configuration
@EnableAuthorizationServer
<span class="fc" id="L28">public class AuthServerOAuth2Config extends AuthorizationServerConfigurerAdapter {</span>
    @Autowired
    @Qualifier(&quot;dataSource&quot;)
    private DataSource dataSource;

    @Autowired
    private AuthenticationManager authenticationManager;

    @Autowired
    private UserService userDetailsService;

    @Autowired
    private PasswordEncoder oauthClientPasswordEncoder;

    @Bean
    public TokenStore tokenStore() {
<span class="fc" id="L44">        return new JdbcTokenStore(dataSource);</span>
    }

    @Bean
    public OAuth2AccessDeniedHandler oauthAccessDeniedHandler() {
<span class="fc" id="L49">        return new OAuth2AccessDeniedHandler();</span>
    }

    @Override
    public void configure(AuthorizationServerSecurityConfigurer oauthServer) {
<span class="fc" id="L54">        oauthServer</span>
<span class="fc" id="L55">                .tokenKeyAccess(&quot;permitAll()&quot;)</span>
<span class="fc" id="L56">                .checkTokenAccess(&quot;isAuthenticated()&quot;)</span>
<span class="fc" id="L57">                .passwordEncoder(oauthClientPasswordEncoder);</span>
<span class="fc" id="L58">    }</span>

    @Override
    public void configure(ClientDetailsServiceConfigurer clients) throws Exception {
<span class="fc" id="L62">        clients.jdbc(dataSource);</span>
<span class="fc" id="L63">    }</span>

    @Override
    public void configure(AuthorizationServerEndpointsConfigurer endpoints) {

<span class="fc" id="L68">        final TokenEnhancerChain tokenEnhancerChain = new TokenEnhancerChain();</span>
<span class="fc" id="L69">        tokenEnhancerChain.setTokenEnhancers(Arrays.asList(tokenEnhancer()));</span>

<span class="fc" id="L71">        endpoints</span>
<span class="fc" id="L72">                .pathMapping(&quot;/oauth/token&quot;,&quot;/token&quot;)</span>
<span class="fc" id="L73">                .tokenStore(tokenStore())</span>
<span class="fc" id="L74">                .authenticationManager(authenticationManager)</span>
<span class="fc" id="L75">                .userDetailsService(userDetailsService)</span>
<span class="fc" id="L76">                .tokenEnhancer(tokenEnhancerChain);</span>
<span class="fc" id="L77">    }</span>

    @Bean
    @Primary
    public DefaultTokenServices tokenServices() {
<span class="fc" id="L82">        final DefaultTokenServices defaultTokenServices = new DefaultTokenServices();</span>
<span class="fc" id="L83">        defaultTokenServices.setTokenStore(tokenStore());</span>
<span class="fc" id="L84">        defaultTokenServices.setSupportRefreshToken(true);</span>
<span class="fc" id="L85">        return defaultTokenServices;</span>
    }

    @Bean
    public TokenEnhancer tokenEnhancer() {
<span class="fc" id="L90">        return new CustomTokenEnhancer();</span>
    }

    @Bean
    public ClientCredentialsTokenEndpointFilter checkTokenEndpointFilter() {
<span class="fc" id="L95">        ClientCredentialsTokenEndpointFilter filter = new ClientCredentialsTokenEndpointFilter(&quot;/oauth/check_token&quot;);</span>
<span class="fc" id="L96">        filter.setAuthenticationManager(authenticationManager);</span>
<span class="fc" id="L97">        filter.setAllowOnlyPost(true);</span>
<span class="fc" id="L98">        return filter;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.5.201910111838</span></div></body></html>